Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 4901)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 1)
@@ -1305,171 +605,394 @@
 
 #if defined( __parallel )
-                   IF ( netcdf_data_format > 4 )  THEN
-!
-!--                   Parallel output in netCDF4/HDF5 format.
+                   IF ( data_output_2d_on_each_pe )  THEN
+!
+!--                   Output of partial arrays on each PE
+#if defined( __netcdf )
+                      IF ( netcdf_output  .AND.  myid == 0 )  THEN
+                         WRITE ( 21 )  simulated_time, do2d_xy_time_count(av), &
+                                       av
+                      ENDIF
+#endif
+                      WRITE ( 21 )  nxl-1, nxr+1, nys-1, nyn+1
+                      WRITE ( 21 )  local_2d
+
+                   ELSE
+!
+!--                   PE0 receives partial arrays from all processors and then
+!--                   outputs them. Here a barrier has to be set, because
+!--                   otherwise "-MPI- FATAL: Remote protocol queue full" may
+!--                   occur.
+                      CALL MPI_BARRIER( comm2d, ierr )
+
+                      ngp = ( nxr-nxl+3 ) * ( nyn-nys+3 )
+                      IF ( myid == 0 )  THEN
+!
+!--                      Local array can be relocated directly.
+                         total_2d(nxl-1:nxr+1,nys-1:nyn+1) = local_2d
+!
+!--                      Receive data from all other PEs.
+                         DO  n = 1, numprocs-1
+!
+!--                         Receive index limits first, then array.
+!--                         Index limits are received in arbitrary order from
+!--                         the PEs.
+                            CALL MPI_RECV( ind(1), 4, MPI_INTEGER,            &
+                                           MPI_ANY_SOURCE, 0, comm2d, status, &
+                                           ierr )
+                            sender = status(MPI_SOURCE)
+                            DEALLOCATE( local_2d )
+                            ALLOCATE( local_2d(ind(1):ind(2),ind(3):ind(4)) )
+                            CALL MPI_RECV( local_2d(ind(1),ind(3)), ngp,      &
+                                           MPI_REAL, sender, 1, comm2d,       &
+                                           status, ierr )
+                            total_2d(ind(1):ind(2),ind(3):ind(4)) = local_2d
+                         ENDDO
+!
+!--                      Output of the total cross-section.
+                         IF ( iso2d_output ) WRITE (21)  total_2d(0:nx+1,0:ny+1)
+!
+!--                      Relocate the local array for the next loop increment
+                         DEALLOCATE( local_2d )
+                         ALLOCATE( local_2d(nxl-1:nxr+1,nys-1:nyn+1) )
+
+#if defined( __netcdf )
+                         IF ( netcdf_output )  THEN
+                            IF ( two_d ) THEN
+                               nc_stat = NF90_PUT_VAR( id_set_xy(av),          &
+                                                       id_var_do2d(av,if),     &
+                                                      total_2d(0:nx+1,0:ny+1), &
+                                start = (/ 1, 1, 1, do2d_xy_time_count(av) /), &
+                                                count = (/ nx+2, ny+2, 1, 1 /) )
+                            ELSE
+                               nc_stat = NF90_PUT_VAR( id_set_xy(av),          &
+                                                       id_var_do2d(av,if),     &
+                                                      total_2d(0:nx+1,0:ny+1), &
+                               start = (/ 1, 1, is, do2d_xy_time_count(av) /), &
+                                                count = (/ nx+2, ny+2, 1, 1 /) )
+                            ENDIF
+                            IF ( nc_stat /= NF90_NOERR )  &
+                                                  CALL handle_netcdf_error( 54 )
+                         ENDIF
+#endif
+
+                      ELSE
+!
+!--                      First send the local index limits to PE0
+                         ind(1) = nxl-1; ind(2) = nxr+1
+                         ind(3) = nys-1; ind(4) = nyn+1
+                         CALL MPI_SEND( ind(1), 4, MPI_INTEGER, 0, 0, comm2d, &
+                                        ierr )
+!
+!--                      Send data to PE0
+                         CALL MPI_SEND( local_2d(nxl-1,nys-1), ngp, MPI_REAL, &
+                                        0, 1, comm2d, ierr )
+                      ENDIF
+!
+!--                   A barrier has to be set, because otherwise some PEs may
+!--                   proceed too fast so that PE0 may receive wrong data on
+!--                   tag 0
+                      CALL MPI_BARRIER( comm2d, ierr )
+                   ENDIF
+#else
+                   IF ( iso2d_output )  THEN
+                      WRITE (21)  local_2d(nxl:nxr+1,nys:nyn+1)
+                   ENDIF
+#if defined( __netcdf )
+                   IF ( netcdf_output )  THEN
                       IF ( two_d ) THEN
-                         iis = 1
+                         nc_stat = NF90_PUT_VAR( id_set_xy(av),                &
+                                                 id_var_do2d(av,if),           &
+                                                local_2d(nxl:nxr+1,nys:nyn+1), &
+                                start = (/ 1, 1, 1, do2d_xy_time_count(av) /), &
+                                              count = (/ nx+2, ny+2, 1, 1 /) )
                       ELSE
-                         iis = is
-                      ENDIF
-
-#if defined( __netcdf )
-!
-!--                   For parallel output, all cross sections are first stored here on a local array
-!--                   and will be written to the output file afterwards to increase the performance.
-                      DO  i = nxl, nxr
+                         nc_stat = NF90_PUT_VAR( id_set_xy(av),                &
+                                                 id_var_do2d(av,if),           &
+                                                local_2d(nxl:nxr+1,nys:nyn+1), &
+                               start = (/ 1, 1, is, do2d_xy_time_count(av) /), &
+                                              count = (/ nx+2, ny+2, 1, 1 /) )
+                      ENDIF
+                      IF ( nc_stat /= NF90_NOERR )  &
+                                                  CALL handle_netcdf_error( 55 )
+                   ENDIF
+#endif
+#endif
+                   do2d_xy_n = do2d_xy_n + 1
+!
+!--                Write LOCAL parameter set for ISO2D.
+                   IF ( myid == 0  .AND.  iso2d_output )  THEN
+                      IF ( section(is,s) /= -1 )  THEN
+                         WRITE ( section_chr, '(''z = '',F7.2,'' m  (GP '',I3, &
+                                               &'')'')'                        &
+                               )  level_z(layer_xy), layer_xy
+                      ELSE
+                         section_chr = 'averaged along z'
+                      ENDIF
+                      IF ( av == 0 )  THEN
+                         rtext = TRIM( do2d(av,if) ) // '  t = ' //    &
+                                 TRIM( simulated_time_chr ) // '  ' // &
+                                 TRIM( section_chr )
+                      ELSE
+                         rtext = TRIM( do2d(av,if) ) // '  averaged t = ' // &
+                                 TRIM( simulated_time_chr ) // '  ' //       &
+                                 TRIM( section_chr )
+                      ENDIF
+                      WRITE (27,LOCAL)
+                   ENDIF
+!
+!--                For 2D-arrays (e.g. u*) only one cross-section is available.
+!--                Hence exit loop of output levels.
+                   IF ( two_d )  THEN
+                      two_d = .FALSE.
+                      EXIT loop1
+                   ENDIF
+
+                CASE ( 'xz' )
+!
+!--                Update the NetCDF xy cross section time axis
+                   IF ( myid == 0 )  THEN
+                      IF ( simulated_time /= do2d_xz_last_time(av) )  THEN
+                         do2d_xz_time_count(av) = do2d_xz_time_count(av) + 1
+                         do2d_xz_last_time(av)  = simulated_time
+                         IF ( .NOT. data_output_2d_on_each_pe  .AND. &
+                              netcdf_output )  THEN
+#if defined( __netcdf )
+                            nc_stat = NF90_PUT_VAR( id_set_xz(av),             &
+                                                    id_var_time_xz(av),        &
+                                                    (/ simulated_time /),      &
+                                         start = (/ do2d_xz_time_count(av) /), &
+                                                    count = (/ 1 /) )
+                            IF ( nc_stat /= NF90_NOERR )  THEN
+                               CALL handle_netcdf_error( 56 )
+                            ENDIF
+#endif
+                         ENDIF
+                      ENDIF
+                   ENDIF
+!
+!--                If required, carry out averaging along y
+                   IF ( section(is,s) == -1 )  THEN
+
+                      ALLOCATE( local_2d_l(nxl-1:nxr+1,nzb:nzt+1) )
+                      local_2d_l = 0.0
+                      ngp = ( nxr-nxl+3 ) * ( nzt-nzb+2 )
+!
+!--                   First local averaging on the PE
+                      DO  k = nzb, nzt+1
                          DO  j = nys, nyn
-                            local_2d_sections(i,j,iis) = local_2d(i,j)
+                            DO  i = nxl-1, nxr+1
+                               local_2d_l(i,k) = local_2d_l(i,k) + &
+                                                 local_pf(i,j,k)
+                            ENDDO
                          ENDDO
                       ENDDO
-#endif
+#if defined( __parallel )
+!
+!--                   Now do the averaging over all PEs along y
+                      CALL MPI_ALLREDUCE( local_2d_l(nxl-1,nzb),              &
+                                          local_2d(nxl-1,nzb), ngp, MPI_REAL, &
+                                          MPI_SUM, comm1dy, ierr )
+#else
+                      local_2d = local_2d_l
+#endif
+                      local_2d = local_2d / ( ny + 1.0 )
+
+                      DEALLOCATE( local_2d_l )
+
                    ELSE
-
-                      IF ( data_output_2d_on_each_pe )  THEN
-!
-!--                      Output of partial arrays on each PE
-#if defined( __netcdf )
-                         IF ( myid == 0 )  THEN
-                            WRITE ( 21 )  time_since_reference_point, do2d_xy_time_count(av), av
-                         ENDIF
-#endif
-                         DO  i = 0, io_blocks-1
-                            IF ( i == io_group )  THEN
-                               WRITE ( 21 )  nxl, nxr, nys, nyn, nys, nyn
-                               WRITE ( 21 )  local_2d
-                            ENDIF
+!
+!--                   Just store the respective section on the local array
+!--                   (but only if it is available on this PE!)
+                      IF ( section(is,s) >= nys  .AND.  section(is,s) <= nyn ) &
+                      THEN
+                         local_2d = local_pf(:,section(is,s),nzb:nzt+1)
+                      ENDIF
+
+                   ENDIF
+
 #if defined( __parallel )
-                            CALL MPI_BARRIER( comm2d, ierr )
-#endif
-                         ENDDO
-
+                   IF ( data_output_2d_on_each_pe )  THEN
+!
+!--                   Output of partial arrays on each PE. If the cross section
+!--                   does not reside on the PE, output special index values.
+#if defined( __netcdf )
+                      IF ( netcdf_output  .AND.  myid == 0 )  THEN
+                         WRITE ( 22 )  simulated_time, do2d_xz_time_count(av), &
+                                       av
+                      ENDIF
+#endif
+                      IF ( ( section(is,s)>=nys .AND. section(is,s)<=nyn ) .OR.&
+                           ( section(is,s) == -1  .AND.  nys-1 == -1 ) )       &
+                      THEN
+                         WRITE (22)  nxl-1, nxr+1, nzb, nzt+1
+                         WRITE (22)  local_2d
                       ELSE
-!
-!--                      PE0 receives partial arrays from all processors and then outputs them. Here
-!--                      a barrier has to be set, because otherwise "-MPI- FATAL: Remote protocol
-!--                      queue full" may occur.
-                         CALL MPI_BARRIER( comm2d, ierr )
-
-                         ngp = ( nxr-nxl+1 ) * ( nyn-nys+1 )
-                         IF ( myid == 0 )  THEN
-!
-!--                         Local array can be relocated directly.
-                            total_2d(nxl:nxr,nys:nyn) = local_2d
-!
-!--                         Receive data from all other PEs.
-                            DO  n = 1, numprocs-1
-!
-!--                            Receive index limits first, then array.
-!--                            Index limits are received in arbitrary order from
-!--                            the PEs.
-                               CALL MPI_RECV( ind(1), 4, MPI_INTEGER, MPI_ANY_SOURCE, 0, comm2d,   &
-                                              status, ierr )
+                         WRITE (22)  -1, -1, -1, -1
+                      ENDIF
+
+                   ELSE
+!
+!--                   PE0 receives partial arrays from all processors of the 
+!--                   respective cross section and outputs them. Here a 
+!--                   barrier has to be set, because otherwise 
+!--                   "-MPI- FATAL: Remote protocol queue full" may occur.
+                      CALL MPI_BARRIER( comm2d, ierr )
+
+                      ngp = ( nxr-nxl+3 ) * ( nzt-nzb+2 )
+                      IF ( myid == 0 )  THEN
+!
+!--                      Local array can be relocated directly.
+                         IF ( ( section(is,s)>=nys .AND. section(is,s)<=nyn )  &
+                            .OR. ( section(is,s) == -1  .AND.  nys-1 == -1 ) ) &
+                         THEN
+                            total_2d(nxl-1:nxr+1,nzb:nzt+1) = local_2d
+                         ENDIF
+!
+!--                      Receive data from all other PEs.
+                         DO  n = 1, numprocs-1
+!
+!--                         Receive index limits first, then array.
+!--                         Index limits are received in arbitrary order from
+!--                         the PEs.
+                            CALL MPI_RECV( ind(1), 4, MPI_INTEGER,            &
+                                           MPI_ANY_SOURCE, 0, comm2d, status, &
+                                           ierr )
+!
+!--                         Not all PEs have data for XZ-cross-section.
+                            IF ( ind(1) /= -9999 )  THEN
                                sender = status(MPI_SOURCE)
                                DEALLOCATE( local_2d )
                                ALLOCATE( local_2d(ind(1):ind(2),ind(3):ind(4)) )
-                               CALL MPI_RECV( local_2d(ind(1),ind(3)), ngp, MPI_REAL, sender, 1,   &
-                                              comm2d, status, ierr )
+                               CALL MPI_RECV( local_2d(ind(1),ind(3)), ngp, &
+                                              MPI_REAL, sender, 1, comm2d,  &
+                                              status, ierr )
                                total_2d(ind(1):ind(2),ind(3):ind(4)) = local_2d
-                            ENDDO
-!
-!--                         Relocate the local array for the next loop increment
-                            DEALLOCATE( local_2d )
-                            ALLOCATE( local_2d(nxl:nxr,nys:nyn) )
-
-#if defined( __netcdf )
-                            IF ( two_d )  THEN
-                               nc_stat = NF90_PUT_VAR( id_set_xy(av),                              &
-                                                       id_var_do2d(av,ivar),                       &
-                                                       total_2d(0:nx,0:ny),                        &
-                                                    start = (/ 1, 1, 1, do2d_xy_time_count(av) /), &
-                                                       count = (/ nx+1, ny+1, 1, 1 /) )
-                            ELSE
-                               nc_stat = NF90_PUT_VAR( id_set_xy(av),                              &
-                                                       id_var_do2d(av,ivar),                       &
-                                                       total_2d(0:nx,0:ny),                        &
-                                                   start = (/ 1, 1, is, do2d_xy_time_count(av) /), &
-                                                       count = (/ nx+1, ny+1, 1, 1 /) )
                             ENDIF
-                            CALL netcdf_handle_error( 'data_output_2d', 54 )
-#endif
-
+                         ENDDO
+!
+!--                      Output of the total cross-section.
+                         IF ( iso2d_output )  THEN
+                            WRITE (22)  total_2d(0:nx+1,nzb:nzt+1)
+                         ENDIF
+!
+!--                      Relocate the local array for the next loop increment
+                         DEALLOCATE( local_2d )
+                         ALLOCATE( local_2d(nxl-1:nxr+1,nzb:nzt+1) )
+
+#if defined( __netcdf )
+                         IF ( netcdf_output )  THEN
+                            nc_stat = NF90_PUT_VAR( id_set_xz(av),             &
+                                                    id_var_do2d(av,if),        &
+                                                    total_2d(0:nx+1,nzb:nzt+1),&
+                               start = (/ 1, is, 1, do2d_xz_time_count(av) /), &
+                                                count = (/ nx+2, 1, nz+2, 1 /) )
+                            IF ( nc_stat /= NF90_NOERR ) &
+                                                  CALL handle_netcdf_error( 57 )
+                         ENDIF
+#endif
+
+                      ELSE
+!
+!--                      If the cross section resides on the PE, send the
+!--                      local index limits, otherwise send -9999 to PE0.
+                         IF ( ( section(is,s)>=nys .AND. section(is,s)<=nyn )  &
+                            .OR. ( section(is,s) == -1  .AND.  nys-1 == -1 ) ) &
+                         THEN
+                            ind(1) = nxl-1; ind(2) = nxr+1
+                            ind(3) = nzb;   ind(4) = nzt+1
                          ELSE
-!
-!--                         First send the local index limits to PE0
-                            ind(1) = nxl; ind(2) = nxr
-                            ind(3) = nys; ind(4) = nyn
-                            CALL MPI_SEND( ind(1), 4, MPI_INTEGER, 0, 0, comm2d, ierr )
-!
-!--                         Send data to PE0
-                            CALL MPI_SEND( local_2d(nxl,nys), ngp, MPI_REAL, 0, 1, comm2d, ierr )
-                         ENDIF
-!
-!--                      A barrier has to be set, because otherwise some PEs may proceed too fast so
-!--                      that PE0 may receive wrong data on tag 0.
-                         CALL MPI_BARRIER( comm2d, ierr )
-                      ENDIF
-
+                            ind(1) = -9999; ind(2) = -9999
+                            ind(3) = -9999; ind(4) = -9999
+                         ENDIF
+                         CALL MPI_SEND( ind(1), 4, MPI_INTEGER, 0, 0, comm2d, &
+                                        ierr )
+!
+!--                      If applicable, send data to PE0.
+                         IF ( ind(1) /= -9999 )  THEN
+                            CALL MPI_SEND( local_2d(nxl-1,nzb), ngp, MPI_REAL, &
+                                           0, 1, comm2d, ierr )
+                         ENDIF
+                      ENDIF
+!
+!--                   A barrier has to be set, because otherwise some PEs may
+!--                   proceed too fast so that PE0 may receive wrong data on
+!--                   tag 0
+                      CALL MPI_BARRIER( comm2d, ierr )
                    ENDIF
 #else
-#if defined( __netcdf )
-                   IF ( two_d ) THEN
-                      nc_stat = NF90_PUT_VAR( id_set_xy(av),                                       &
-                                              id_var_do2d(av,ivar),                                &
-                                              local_2d(nxl:nxr,nys:nyn),                           &
-                                              start = (/ 1, 1, 1, do2d_xy_time_count(av) /),       &
-                                              count = (/ nx+1, ny+1, 1, 1 /) )
-                   ELSE
-                      nc_stat = NF90_PUT_VAR( id_set_xy(av),                                       &
-                                              id_var_do2d(av,ivar),                                &
-                                              local_2d(nxl:nxr,nys:nyn),                           &
-                                              start = (/ 1, 1, is, do2d_xy_time_count(av) /),      &
-                                              count = (/ nx+1, ny+1, 1, 1 /) )
-                   ENDIF
-                   CALL netcdf_handle_error( 'data_output_2d', 447 )
-#endif
-#endif
-
-!
-!--                For 2D-arrays (e.g. u*) only one cross-section is available.
-!--                Hence exit loop of output levels.
-                   IF ( two_d )  THEN
-                      IF ( netcdf_data_format < 5 )  two_d = .FALSE.
-                      EXIT loop1
-                   ENDIF
-
-                CASE ( 'xz' )
-!
-!--                Update the netCDF xz cross section time axis.
-!--                In case of parallel output, this is only done by PE0 to increase the performance.
-                   IF ( time_since_reference_point /= do2d_xz_last_time(av) )  THEN
-                      do2d_xz_time_count(av) = do2d_xz_time_count(av) + 1
-                      do2d_xz_last_time(av)  = time_since_reference_point
-                      IF ( myid == 0 )  THEN
-                         IF ( .NOT. data_output_2d_on_each_pe  .OR.  netcdf_data_format > 4 )  THEN
-#if defined( __netcdf )
-                            nc_stat = NF90_PUT_VAR( id_set_xz(av),                                 &
-                                                    id_var_time_xz(av),                            &
-                                                    (/ time_since_reference_point /),              &
-                                                    start = (/ do2d_xz_time_count(av) /),          &
+                   IF ( iso2d_output )  THEN
+                      WRITE (22)  local_2d(nxl:nxr+1,nzb:nzt+1)
+                   ENDIF
+#if defined( __netcdf )
+                   IF ( netcdf_output )  THEN
+                      nc_stat = NF90_PUT_VAR( id_set_xz(av),                   &
+                                              id_var_do2d(av,if),              &
+                                              local_2d(nxl:nxr+1,nzb:nzt+1),   &
+                               start = (/ 1, is, 1, do2d_xz_time_count(av) /), &
+                                              count = (/ nx+2, 1, nz+2, 1 /) )
+                      IF ( nc_stat /= NF90_NOERR )  &
+                                                  CALL handle_netcdf_error( 58 )
+                   ENDIF
+#endif
+#endif
+                   do2d_xz_n = do2d_xz_n + 1
+!
+!--                Write LOCAL-parameter set for ISO2D.
+                   IF ( myid == 0  .AND.  iso2d_output )  THEN
+                      IF ( section(is,s) /= -1 )  THEN
+                         WRITE ( section_chr, '(''y = '',F8.2,'' m  (GP '',I3, &
+                                               &'')'')'                        &
+                               )  section(is,s)*dy, section(is,s)
+                      ELSE
+                         section_chr = 'averaged along y'
+                      ENDIF
+                      IF ( av == 0 )  THEN
+                         rtext = TRIM( do2d(av,if) ) // '  t = ' //    &
+                                 TRIM( simulated_time_chr ) // '  ' // &
+                                 TRIM( section_chr )
+                      ELSE
+                         rtext = TRIM( do2d(av,if) ) // '  averaged t = ' // &
+                                 TRIM( simulated_time_chr ) // '  ' //       &
+                                 TRIM( section_chr )
+                      ENDIF
+                      WRITE (28,LOCAL)
+                   ENDIF
+
+                CASE ( 'yz' )
+!
+!--                Update the NetCDF xy cross section time axis
+                   IF ( myid == 0 )  THEN
+                      IF ( simulated_time /= do2d_yz_last_time(av) )  THEN
+                         do2d_yz_time_count(av) = do2d_yz_time_count(av) + 1
+                         do2d_yz_last_time(av)  = simulated_time
+                         IF ( .NOT. data_output_2d_on_each_pe  .AND. &
+                              netcdf_output )  THEN
+#if defined( __netcdf )
+                            nc_stat = NF90_PUT_VAR( id_set_yz(av),             &
+                                                    id_var_time_yz(av),        &
+                                                    (/ simulated_time /),      &
+                                         start = (/ do2d_yz_time_count(av) /), &
                                                     count = (/ 1 /) )
-                            CALL netcdf_handle_error( 'data_output_2d', 56 )
-#endif
-                         ENDIF
-                      ENDIF
-                   ENDIF
-
-!
-!--                If required, carry out averaging along y
-                   IF ( section(is,s_ind) == -1 )  THEN
-
-                      ALLOCATE( local_2d_l(nxl:nxr,nzb_do:nzt_do) )
-                      local_2d_l = 0.0_wp
-                      ngp = ( nxr-nxl + 1 ) * ( nzt_do-nzb_do + 1 )
+                            IF ( nc_stat /= NF90_NOERR )  THEN
+                               CALL handle_netcdf_error( 59 )
+                            ENDIF
+#endif
+                         ENDIF
+                      ENDIF
+                   ENDIF
+!
+!--                If required, carry out averaging along x
+                   IF ( section(is,s) == -1 )  THEN
+
+                      ALLOCATE( local_2d_l(nys-1:nyn+1,nzb:nzt+1) )
+                      local_2d_l = 0.0
+                      ngp = ( nyn-nys+3 ) * ( nzt-nzb+2 )
 !
 !--                   First local averaging on the PE
-                      DO  k = nzb_do, nzt_do
-                         DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         DO  j = nys-1, nyn+1
                             DO  i = nxl, nxr
-                               local_2d_l(i,k) = local_2d_l(i,k) + local_pf(i,j,k)
+                               local_2d_l(j,k) = local_2d_l(j,k) + &
+                                                 local_pf(i,j,k)
                             ENDDO
                          ENDDO
@@ -1477,12 +1000,12 @@
 #if defined( __parallel )
 !
-!--                   Now do the averaging over all PEs along y
-                      IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-                      CALL MPI_ALLREDUCE( local_2d_l(nxl,nzb_do), local_2d(nxl,nzb_do), ngp,       &
-                                          MPI_REAL, MPI_SUM, comm1dy, ierr )
+!--                   Now do the averaging over all PEs along x
+                      CALL MPI_ALLREDUCE( local_2d_l(nys-1,nzb),              &
+                                          local_2d(nys-1,nzb), ngp, MPI_REAL, &
+                                          MPI_SUM, comm1dx, ierr )
 #else
                       local_2d = local_2d_l
 #endif
-                      local_2d = local_2d / ( ny + 1.0_wp )
+                      local_2d = local_2d / ( nx + 1.0 )
 
                       DEALLOCATE( local_2d_l )
@@ -1490,8 +1013,9 @@
                    ELSE
 !
-!--                   Just store the respective section on the local array (but only if it is
-!--                   available on this PE!)
-                      IF ( section(is,s_ind) >= nys  .AND.  section(is,s_ind) <= nyn )  THEN
-                         local_2d = local_pf(:,section(is,s_ind),nzb_do:nzt_do)
+!--                   Just store the respective section on the local array
+!--                   (but only if it is available on this PE!)
+                      IF ( section(is,s) >= nxl  .AND.  section(is,s) <= nxr ) &
+                      THEN
+                         local_2d = local_pf(section(is,s),:,nzb:nzt+1)
                       ENDIF
 
